/*****************************************************************************/
/*                                                                           */
/*                           OCO SOURCE MATERIALS                            */
/*                             IBM CONFIDENTIAL                              */
/*                                    OR                                     */
/*                        IBM CONFIDENTIAL RESTRICTED                        */
/*            WHEN COMBINED WITH THE AGGREGATED OCO SOURCE MODULES           */
/*                           FOR THIS PROGRAM PRODUCT                        */
/*                                                                           */
/*   VisualAge Generator Server for OS/2, AIX, HP-UX, SUN, and Windows NT    */
/*                          Version 4.5  5697-C28                            */
/*                    (C) COPYRIGHT IBM CORP. 1994,2000                      */
/*                                                                           */
/*****************************************************************************/
/*****************************************************************************/
/*  File Name: cso2api.h                                                     */
/*****************************************************************************/
/*  Warning !                                                             @FH*/
/*  This file is used on OS/400.  Please do not make any changes that     @FH*/
/*  go beyond column 80.  Thanks for your help.                           @FH*/
/*  Warning !                                                             @FH*/
/*****************************************************************************/
/*  Type    Date    Userid    Description of problem                         */
/*                                                                           */
/*  A1     9/20/95  JSnyder   F3502 - BIDI Attribute Conversion              */
/*  B1     2/06/96  SRobin    F4346 - DUOW Support                           */
/*  B2     3/01/96  JSnyder   F4449 - Changes for C++ WGS compiles           */
/*                                    under Windows.  Changed EXPORT         */
/*                                    define to CSOEXPORT.                   */
/*  B3     3/07/96  JSnyder   F4060 - DCE/NT Line Item                       */
/*  B4     3/28/96  JSnyder   F4472 - DCE/NT Line Item                       */
/*  B5     4/14/96  JSnyder   F4702 - DCE/NT Line Item                       */
/*  B6     4/15/96  JSnyder   F4702 - Add lines for IBMCPPW per Rob          */
/*  B7     6/19/96  CIPRIANO  D5250 - CMGETERROR intial code                 */
/*  B8     7/11/96  PHoffman  F5423 - PACBASE middleware                     */
/*  B9     8/21/96  PHoffman  D5627 - Correct Commit/Rollback Msgs           */
/*  BA     8/16/96  CIPRIANO  F5587 - Power Server API data types            */
/*  BA     8/28/96  CIPRIANO  D5688 - redo 5587 changes                      */
/*  BB    10/15/96  JSnyder   F5759 - Add MVS DCE support                    */
/*  BC    11/04/96  JSnyder   F5759 - Add MVS VM support                     */
/*  BD    02/17/97  Lisar     D6096 - Native TCPIP support                   */
/*  BE    03/28/97  YCLUI     F6040 - ODBC support                           */
/*  BF     5/10/97  PHoffman  F6335 - Java Beans                             */
/*  BG    06/26/97  Lisar     F6327 - Native LU2 support                     */
/*  BH    06/26/97  srobin    F6327 - Native LU2 support                     */
/*  BI    07/22/97  JSnyder   F6742 - add #pragma pack() for COBGEN          */
/*  BJ    07/31/97  rwbrown   D6868 - add check for CMNWIN                   */
/*  BK    09/02/97  PHoffman  D7458 - add QUERYDB EZECONCT function          */
/*  BL    09/02/97  JSnyder   D???? - add CMST_NPIPES                        */
/*  BM    10/22/97  hoffman   F8046 - Planetworks - uid/pwd in cod           */
/*  BU    11/03/97  hoffman   F7882 - Planetworks data conv rewrite          */
/*  BV    02/06/98  lisar     F8489 - Add local call support                 */
/*  BW    02/10/98  lisar     F8389 - Callable ITF (add CMLUW_ITF)           */
/*                                    & local call DIRECT support            */
/*  BX    03/09/98  CProffer  F8562 - Add Oracle support                     */
/*  C1    03/17/98  Herring   F8532 - Add driver for exci                    */
/*  C2    04/15/98  Hoffman   F8632 - PowerServer Float/Double Support       */
/*  C3    08/19/98  proffer   F4070 - Add support for Sun                    */
/*  C4    12/10/98  JSnyder  F10204 - Fix build problems                     */
/*  C5    01/18/99  CProffer D10358 - Define CMCOMMIT2 and CMROLLBK2         */
/*  C6    04/20/99  KOCH     F10729 - Add link table session bean support    */
/*  C7    05/03/99  KOCH     F10793 - Support VA C++ compiler                */
/*  C8    05/17/99  JSnyder  F10911 - Add support for CMCONVERSEUI API       */
/*  C9    05/27/99  JSnyder  F10965 - Fix support for CMCONVERSEUI API       */
/*  CA    07/13/99  JSnyder  D11128 - fix handle passed to CMCONV            */
/*  CB    08/24/99  Koch     F11969 - Add CMINITMVS for OS390                */
/*  F0    02/04/00  hoffman  F12716 - MQ Common Services                     */
/*  F1    02/16/00  JSnyder  F12795 - Add support for CMGetUIRecord API      */
/*  F2    02/22/00  hoffman  D12830 - prevent PFN definition collision       */
/*  F3    03/06/00  JSnyder  F12867 - port JNI to Solaris                    */
/*  F4    03/15/00  Hoffman  D12934 - OS/400 Conversion Support              */
/*  F5    03/17/00  dewittsc F12976 - WGS V4.5 Enhancements                  */
/*  F6    03/23/00  zeynepl  F13040 - Improve AIX, OS/2 Compilation for V4.5 */
/*  F7    03/26/00  SANJAYC  D13057 - Corrected compile errors for sun & HP  */
/*  F8    03/29/00  dewittsc F12775 - Add CMCC_JNI_MEMORY_ERROR              */
/*  F9    03/31/00  SANJAYC  D13096 - Rolled back changes for sun and HP     */
/*  FA    04/09/00  SANJAYC  ------ - Added fix for SUN compile errors       */
/*  FB    04/27/00  SANJAYC  D13329 - Added fix for SUN compiles             */
/*  FC    05/01/00  hoffman  D13358 - Load CSO MQ Driver on MQ CMINIT        */
/*  FD    05/11/00  mheitz   F13410 - Add package & apptype=VGJAVA to lnktbl */
/*  FG    05/16/00  zeynepl  PQ36769- Fix Cancel Button on CSOPRMPT          */
/*  FH    05/20/00  hoffman  D13526 - CSO session not reused because of @FC  */
/*  FI    06/07/00  mheitz   F13642 - fix #pragma pack() for HP compiler     */
/*  FJ    07/27/00  mheitz   D14151 - Allow remotecomtype=JAVA400 in linkage */
/*  FK    08/28/00  proffer  D14328 - Force alignment of CMCOMP structure    */
/*  FL    01/11/01  proffer  D14522 - Force alignment of CMCVOD structure    */
/*  FN    10/23/01  zeynepl  D14719 - Add userid/passwd support for gen. time*/
/*  FO    11/17/01  lisar    PQ49411- CMINIT entry point naming conflict     */
/*  FP    12/13/01  lisar    D14789 - Fix compile error in previous fix      */
/*  FQ    12/18/01  lisar    D14804 - Compile error, line > 80 chars         */
/*  FR    03/14/02  zeynepl  D14874 - Add support to call Java Apps          */
/*****************************************************************************/

#ifndef CSO2API_H
#define CSO2API_H

/*---------------@F6 The following logic changed to add AIX----------------- */
/*                                                                           */
/* #if !defined(CSO400) || defined(CSOWIN32)                             @F4 */
/*  #pragma pack(1)                                                      @BI */
/* #else                                                                 @F4 */
/*  #define IS400                                                        @F4 */
/* #endif                                                                @F4 */
/*---------------------------------------------------------------------------*/

/*@F6*/
#if defined(CSO400)
   #define IS400
#elif defined FCW_HP                  /* @FI */
   #pragma pack 1                     /* @FI */
#elif defined(CSOWIN32) || !defined(FCW_AIX)
   #pragma pack(1)
#endif

/* Constant Values */
#define CMCTNAMEL 8                    /* Conversion table name length     */
#define CMRCHARL  2                    /* DBCS replacement char length     */

#define USERID_PRMPT  2                /* @FG */

#ifndef CSO_MQI  /* @FA */
 #define CMEMSGL  72                    /* Error message insert length   @B8*/
 #define CMEMSGC  10                    /* Error message insert count    @B9*/
#endif /* @FA */

/* Types */
/* @FA begin */
#ifndef CSO_MQI
typedef long    CMLONG;                /* long integer                     */
typedef char    CMCHAR;                /* character                        */
typedef CMCHAR  CMCHAR2[2];            /* Two character field              */
typedef CMCHAR  CMCHAR4[4];            /* Four character field             */
typedef CMCHAR  CMCHAR8[8];            /* Eight character field            */
typedef CMLONG  CMCC;                  /* completion code                  */
typedef CMCHAR  CMCHAR6[6];                                              /*@F4*/
typedef CMCHAR  CMCHAR9[9];                                              /*@F4*/
typedef CMCHAR  CMCHAR97[97];                                            /*@F4*/
typedef CMCHAR  CMDESC;                /* parameter buffer description     */
#endif
/* @FA end */
typedef CMCHAR  CMNAME;                /* name (null terminated string)    */
typedef CMCHAR2 CMRCHAR;               /* DBCS replacement character       */
typedef CMCHAR  CMCHAR18[18];          /* Eighteen character field         */

#ifndef CSO_MQI  /* @FA */
typedef CMCHAR  CMEMSG[CMEMSGL];       /* Error message insert    @B9      */
#endif           /* @FA */

typedef CMCHAR  CMMSG;                 /* null terminated error str  @B7   */
typedef CMCHAR  CMSBT[256];            /* Single byte conversion array     */
typedef CMCHAR *CMDBT[256];            /* Double byte conversion array     */
typedef CMCHAR  CMPARM;                /* parameter - format unknown       */
typedef CMPARM *PCMPARM;               /* parameter pointer                */
typedef CMDESC *PCMDESC;               /* description pointer              */
typedef short   CMSHORT;               /* short integer                    */
typedef void*   CMSQLCA;               /* completion code            @B1   */
typedef CMCHAR  CMCHAR50[50];                                            /*@F4*/

#define  MAX_LINE      512             /* @BH                              */

/* Constant Values for TRUE and FALSE */
#define TRUE        1
#define FALSE       0

#define CMINITFORMQ 2                                                 /*@FH*/

/* Constant Values for Completion Code */
#define CMCC_OK    0
#define CMCC_SQLWARN  2                /* @B1                              */
#define CMCC_WARN  4
#define CMCC_ERROR 8
#define CMCC_12BYTE_ERROR 12
#define CMCC_SECURITY 16
#define CMCC_JNI_MEMORY_ERROR  32       /* Used in JNI when out of memory  @F8*/
                                        /* and CMCOMP is unavailable.      @F8*/

/* Constant values for Connect Type */
#define  CMCONCT_IMPLICIT     1

/* Constant values for Unit of Work Options */                       /* @B1*/
#define CMCONCT_RUOW    "R"            /* @B1                              */
#define CMCONCT_D1E       "D1E"        /* @B1                              */
#define CMCONCT_D1C       "D1C"        /* @B1                              */
#define CMCONCT_D1A       "D1A"        /* @B1                              */
#define CMCONCT_D2E       "D2E"        /* @B1                              */
#define CMCONCT_D2C       "D2C"        /* @B1                              */
#define CMCONCT_D2A      "D2A"         /* @B1                              */
#define CMCONCT_DISC        "DISC"     /* @B1                              */
#define CMCONCT_DALL        "DALL"     /* @B1                              */
#define CMCONCT_DCURRENT    "DCURRENT" /* @BK                              */
#define CMCONCT_SET         "SET"      /* @B1                              */
#define CMCONCT_QUERYDB     "QUERYDB"  /* @BK                              */

/* Constant values for Servername Type */
#define CMCONCT_BLANKS        1
#define CMCONCT_RESET         2

/* Constant values for Connect Type                                    *@BE*/
#define CMCONCT_SQL_PROCESS  0x00000001
#define CMCONCT_EZECONCT     0x00000002
#define CMCONCT_ODBC         0x00010000
#define CMCONCT_ORACLE       0x00020000

#define CMCONCT_ISL_RPR      0x01000000/* Repeatable read                  */
#define CMCONCT_ISL_TXS      0x02000000/* trn serializable                 */
#define CMCONCT_ISL_RUC      0x03000000/* read uncommitted                 */
#define CMCONCT_ISL_RCM      0x04000000/* read committed                   */
#define CMCONCT_ISL_TXV      0x05000000/* trn versioning *BE               */

/* Constant value for Number Connect Settings  */
#define NUMSETTINGS       3

/* Linkage Table Structure */
#define MAX_APPLNAME    9
#define MAX_LIBRARY     20
#define MAX_EXTNAME     40
#define MAX_CONTABLE    9              /* 8 chars + 1 for NULL             */
#define MAX_LOCATION    20
#define MAX_SERVERID    20
#define MAX_LINKTBLNAME 80
#define MAX_UID         20             /* maximum userid w/Null   @BM      */
#define MAX_PWORD       20             /* Maximum password w/Null @BM      */
#define MAX_NAMESERVER  80          /* Maximum session bean name server @C6*/
#define MAX_PACKAGE    100             /* Maximum package name          @FD*/
#define MAX_JAVA_SERVER_APP_NAME 109   /* @FR                              */



typedef struct
{
  CMCHAR4 StrucId;                     /* Structure identifier "COD"       */
  CMLONG  Version;                     /* Structure version number         */
  CMLONG  Protocol;                    /* Communications protocol          */
  CMLONG  LuwType;                     /* Logical unit of work type        */
  CMLONG  AppType;                     /* Remote application type          */
  CMLONG  Parmform;                    /* Parameter format                 */
  CMNAME  ConversionTable[MAX_CONTABLE];       /* Conversion table name    */
  CMNAME  Location[MAX_LOCATION];      /* Server system name               */
  CMNAME  ServerId[MAX_SERVERID];      /* Server channel id                */
  CMNAME  LinkageTableName[MAX_LINKTBLNAME];   /* Linkage table name       */
  CMNAME  Library[MAX_LIBRARY];        /* Library name                     */
  CMNAME  ExtName[MAX_EXTNAME];        /* External name                    */
  /* Version 1 COD ends here                                      @BM*/
  CMNAME  UserId[MAX_UID];             /* User Identifier         @BM      */
  CMNAME  Password[MAX_PWORD];         /* Password                @BM      */
  /* Version 2 COD ends here                                      @C6      */
  CMNAME  NameServer[MAX_NAMESERVER];  /* Session bean name server @C6     */
  /* Version 3 COD ends here                                      @FD      */
  CMNAME  Package[MAX_PACKAGE];        /* Pacakge name            @FD      */
} CMCOD;

/* Constant values for StrucId */
#define CMCOD_STRUC_ID "COD"

/* Constant values for Version */
#define CMCOD_VERSION_1 1
#define CMCOD_VERSION_2 2              /* @BM                              */
#define CMCOD_VERSION_WITH_UID 2       /* @BM                              */
#define CMCOD_VERSION_3 3              /* @C6                              */
#define CMCOD_VERSION_4 4              /* @FD                              */

/* Constant values for communications protocol */
#define CMST_RUNTIME_BIND  0
#define CMST_ROUTING_TABLE 1
#define CMST_DNA_ECI_C2    2
#define CMST_DNA_LU2       3
#define CMST_DNA_LU62      4
#define CMST_DNA_TCPIP     5
#define CMST_DNA_NPIPES    6
#define CMST_ECI_C2        7           /* CICS  OS/2                       */
#define CMST_ECI_CM        8           /* CICSCLIENT                       */
#define CMST_CA400         9
#define CMST_DBSP          10
#define CMST_APPC_IMS      11
#define CMST_CMCONCT       12          /* @B1                              */
#define CMST_DCE           13          /* DCE        @B3                   */
#define CMST_DCE_SECURE    14          /* DCE_SECURE @B4                   */
#define CMST_PACBASE       15          /* CGI PACBASE middleware @B8       */
#define CMST_DCE_IMS       16          /* DCEIMS  @BB                      */
#define CMST_DCE_CICS      17          /* DCECICS @BB                      */
#define CMST_DCE_VM        18          /* DCEVM   @BC                      */
#define CMST_TCPIP         19          /* Native TCPIP support         @BD */
#define CMST_LU2           20          /* Native LU2   support         @BG */
#define CMST_NPIPES        21          /* Native Named Pipes support   @BL */
#define CMST_IPC           22          /* Native Local Call Support    @BV */
#define CMST_DIRECT        23          /* Native Local Call Direct Sup.@BW */
#define CMST_EXCI          24          /* mvs cics exci                @C1 */
#define CMST_JAVA400       25          /* Java AS/400                  @FJ */
#define CMST_GEN_FTP       26          /* @FN                              */
#define CMST_JTCPIP        26          /* @FR                              */


/* Constant Values for Logical Unit of Work Type */
#define CMLUW_CLIENT 0
#define CMLUW_SERVER 1

/* Constant Values for Remote Application Type */
#define CMLUW_VG    0
#define CMLUW_NONVG 1
                             /* @BW - add ITF */
#define CMLUW_ITF   2
#define CMLUW_VGJAVA  3                /* @FD                              */

/* Constant Values for Parameter Format    */
#define CMPF_COMMPTR  0
#define CMPF_COMMDATA 1

/* Constant Values for Conversion Table Name */
#define CMCT_NO_CONVERSION  0
#define CMCT_DEFAULT_NLS    1
#define CMCT_DEFAULT_SYSTEM 2
#define CMCT_DNA_CONVERSION 3

/* Constant Values for Server System Name */
#define CMLO_NO_LOCATION 0

/* Constant Values for Server Channel Id */
#define CMSE_NO_SERVER_ID 0

/* CMCVOD - Convert Options Descriptor  */
#if defined FCW_HP                     /* @FL                              */
#pragma pack 4
#elif defined FCW_SUN                  /* @FL                              */
#pragma pack(4)
#endif                                 /* @FL                              */

typedef struct
{
  CMCHAR4  StrucId;                    /* Structure identifier "CVOD"      */
  CMLONG   Version;                    /* Structure version number         */
  CMLONG   Direction;                  /* Direction                        */
  CMNAME   ConversionTable[MAX_CONTABLE];      /* Conversion Table Name    */
} CMCVOD;

#if defined FCW_HP                     /* @FL                              */
#pragma pack
#elif defined FCW_SUN                  /* @FL                              */
#pragma pack()
#endif                                 /* @FL                              */

/* Constant values for Structure identifier "CVOD"                   */
#define CMCVOD_STRUC_ID          "CVOD"

/* Constant values for Structure version number                      */
#define CMCVOD_VERSION_1         1

/* Constant values for Direction                                     */
#define CMCD_LOCAL_TO_REMOTE     1
#define CMCD_REMOTE_TO_LOCAL     2

/* CMPARMLEN - sub struct of a CM Parameter Descriptor @BA */
typedef struct
{
  CMCHAR   parmLengthIndicator;        /* should be const CONV_MAX_LENGTH  */
  CMLONG   parmLength;
} CMPARMLEN;

/* CMITEM - sub struct of a CM Parameter Descriptor @BA */
typedef struct
{
  CMCHAR   itemIndicator;              /* should be one of DATA_xxxxx const*/
  CMSHORT  itemLength;
} CMITEM;

/* CMOCCURS - sub struct of a CM Parameter Descriptor @BA */
typedef struct
{
  CMCHAR   occursIndicator;            /* should be const OCC_STR          */
  CMSHORT  occursItemCount;            /* number of CMITEMs that follow    */
  CMSHORT  occursDimension;       /* number of elements in the occurs/array*/
} CMOCCURS;

/* CMPARMEND - last field of a CM Parameter Descriptor @BA */
typedef CMCHAR  CMPARMEND;             /* should be const END_DESC         */

#if defined FCW_HP                     /* @FK                              */
#pragma pack 4
#elif defined FCW_SUN                  /* @FK                              */
#pragma pack(4)
#endif                                 /* @FK                              */

#ifndef CSO_MQI                        /* @FA begin                        */
typedef struct
{
  CMCC   CompCode;                     /* Completion code                  */
  CMLONG Reason;                      /* Reason code (Error message number)*/
  CMLONG EmsgCount;                    /* Error insert count               */
  CMEMSG Emsg[CMEMSGC];              /* Error insert array              @B9*/
} CMCOMP;
#endif                                 /* @FA end                          */

/* Prototypes */




#if defined __OS2__ || defined FCW_UNIX || defined __MVS__  || defined IS400
                                                            /*@C1, @F4, @FH*/

  #define CSOEXPORT                    /* @B2                              */
  #undef FAR                           /* @B2                              */
  #define FAR                          /* @B2                              */

  #if defined __OS2__
    #define SYSTEM _System
    #define SYSCALL  _System
  #else
   /*#ifndef CSO_MQI  || defined CSO_HP*/                            /* @FA*/
    #define SYSTEM
  /* #endif */                                                       /* @FA*/
    #define SYSCALL
  #endif


#if defined FCW_SUN || defined FCW_AIX  /*     Same as for CMINIT       @FO*/
  #if defined __IBMCPP__ || defined __cplusplus
    extern "C" {
  #endif
#else                                  /* @F3                              */
#endif

  /* Added by @CB as additional entry point CMINITMVS for MVS only      @CB*/
  /* Renamed CMINITMVS->CMINITVG & for all environments by @FO          @FO*/
  /* Client access initialization. Avoid conflict with CMINIT in APPC   @CB*/
  CMCC SYSTEM CMINITVG(               /* @CB @FO-Modified               @FO*/
             CMLONG *Hconn,               /* Connection handle (output) @CB*/
             CMCOMP *Cmcomp,              /* Completion status (output) @CB*/
             void   *winHandle,/* Window handle used by Windows (input) @CB*/
             CMLONG *forceNewHandle       /* Returns new handle (input) @CB*/
             );                                                      /* @CB*/

#if defined FCW_SUN || defined FCW_AIX                               /* @CB*/
  #if defined __IBMCPP__ || defined __cplusplus
    }
  #endif
#endif                                                               /* @CB*/

#if defined FCW_SUN || defined FCW_AIX /* @F5                              */
  #if defined __IBMCPP__ || defined __cplusplus
    extern "C" {
  #endif
#else                                  /* @F3                              */
#endif
  /* Client access initialization */
  CMCC SYSTEM CMINIT(
             CMLONG *Hconn,                   /* Connection handle (output)*/
             CMCOMP *Cmcomp,                  /* Completion status (output)*/
             void   *winHandle,    /* Window handle used by Windows (input)*/
             CMLONG *forceNewHandle           /* Returns new handle (input)*/
             );

  /* Client access server call */
  CMCC SYSTEM CMCALL(
             CMLONG Hconn,             /* Connection handle (input)        */
             CMNAME *Applname,           /* Server application name (input)*/
             CMLONG ParmCount,         /* Parameter count (input)          */
             CMPARM **Parameter,  /* Parameter pointer array (input/output)*/
             CMDESC **Description,            /* Desc pointer array (input)*/
             CMCOD  *Cmcod,              /* Call options descriptor (input)*/
             CMCOMP *Cmcomp                   /* Completion status (output)*/
             );

  /* Client access close */
  CMCC SYSTEM CMCLOSE(
             CMLONG Hconn,             /* Connection handle (input)        */
             CMCOMP *Cmcomp                   /* Completion status (output)*/
             );

  /* Client access commit */
  CMCC SYSTEM CMCOMMIT(
             CMLONG Hconn,             /* Connection handle (input)        */
             CMCOMP *Cmcomp                   /* Completion status (output)*/
             );

  /* Internal version of CMCOMMIT, returns SQL code */
  CMCC SYSTEM CMCOMMIT2(
             CMLONG Hconn,             /* Connection handle (input)        */
             CMCOMP *Cmcomp,                  /* Completion status (output)*/
             CMLONG *sqlCode           /* SQL code                         */
             );

  /* Client access rollback */
  CMCC SYSTEM CMROLLBK(
             CMLONG Hconn,             /* Connection handle (input)        */
             CMCOMP *Cmcomp                   /* Completion status (output)*/
             );

  /* Internal version of CMROLLBK, returns SQL code */
  CMCC SYSTEM CMROLLBK2(
             CMLONG Hconn,             /* Connection handle (input)        */
             CMCOMP *Cmcomp,                  /* Completion status (output)*/
             CMLONG *sqlCode           /* SQL code                         */
             );

  /* Client access convert */
  CMCC SYSTEM CMCONV(
             CMLONG Hconn,             /* Client access handle (input)     */
             CMCVOD *Cmcvod,          /* Convert options descriptor (input)*/
             CMPARM *Parameter,                 /* Parameter (input/output)*/
             CMDESC *Description,          /* Parameter Description (input)*/
             CMCOMP *Cmcomp                   /* Completion status (output)*/
             );

  /* Client access get error */
  CMCC SYSTEM CMGETERROR(              /* @B7                              */
             CMCOMP *Cmcomp,                   /* Completion status (input)*/
             CMLONG *errStrBufLen,      /* error string buffer length (i/o)*/
             CMMSG  *errStrBuf              /* error string buffer (output)*/
             );

  /* Client access Common Set Current Communication Handle */        /* @B1*/
  CMCC SYSTEM CMSetCurrentHandle(
             CMLONG    *Hconn,                                       /* @B1*/
             CMCOMP   *Cmcomp                                        /* @B1*/
             );

  /* Client access Read From Linkage Table Into CMCOD */             /* @BF*/
  CMCC SYSTEM CMReadFromLinkTbl(       /* @BF                              */
             CMLONG    Hconn,          /* @BF                              */
             CMNAME   *Applname,                                     /* @BF*/
             CMCOD    *Cmcod,                                        /* @BF*/
             CMCOMP   *Cmcomp                                        /* @BF*/
             );                                                      /* @BF*/

  /* Client access Get Full Path Name                 */             /* @BF*/
  CMCC SYSTEM CMGetFullPathName(       /* @BF                              */
             CMNAME   *filename,                                     /* @BF*/
             CMNAME   *pathname                                      /* @BF*/
             );                                                      /* @BF*/

  /* Client access Common Get Database Version  */                   /* @B1*/
  CMCC SYSTEM CMGetDBVersion(
             CMLONG    Hconn,          /* @B1                              */
             short *Version,                                         /* @B1*/
             CMCOMP   *Cmcomp                                        /* @B1*/
             );

  /* Client access Common Get Oracle Version  */                     /* @BX*/
  CMCC SYSTEM CMGetOracleVersion(
             CMLONG    Hconn,          /* @BX                              */
             short     *Version,                                     /* @BX*/
             CMCOMP    *Cmcomp                                       /* @BX*/
             );

  /* Client access Common connect  */                                /* @B1*/
  CMCC SYSTEM CMCONCT(                 /* @B1                              */
             CMLONG    Hconn,          /* @B1                              */
             CMLONG    *ConnectReason,                               /* @B1*/
             CMCHAR8   *pUserid,                                     /* @B1*/
             CMCHAR8   *pPassword,                                   /* @B1*/
             CMCHAR18   *pServerName,                                /* @B1*/
             CMCHAR8   *pProduct,                                    /* @B1*/
             CMCHAR8   *pRelease,                                    /* @B1*/
             CMCHAR8   *pUow,                                        /* @B1*/
             CMSQLCA   *pSQLCA,                                      /* @B1*/
             CMCOMP   *Cmcomp
             );

  /* Client access Common Converse UI Record */                      /* @C8*/
  CMCC SYSTEM CMConverseUI(            /* @C8                              */
             void      *UIBuffer,                                    /* @C8*/
             short     *terminateRequestedFlag                       /* @C8*/
             );

  /* Client access Common Get UI Record */                           /* @F1*/
  CMCC SYSTEM CMGetUIRecord(           /* @F1                              */
             void      *gatewayBuffer,                               /* @F1*/
             void      *UIBuffer                                     /* @F1*/
             );

#if defined FCW_SUN || defined FCW_AIX                               /* @F5*/
  #if defined __IBMCPP__ || defined __cplusplus
    }
  #endif
#endif                                                               /* @F5*/

#else

 #if defined CSO_VA_CPP                /* @C7                              */

 /*removed conditional compile CSO_MQI  @FB */

    #define CSOEXPORT _declspec(dllexport)       /* @C7                      */
    #define SYSTEM                     /* @C7                              */
    #define FAR                          /* @C7                              */

  #define SYSCALL                      /* @C7                              */

 #else                                 /* @C7                              */
  #define CSOEXPORT _export
  #define SYSTEM
  #define SYSCALL __cdecl

  #if defined CSOWIN32
     #undef CSOEXPORT                  /* @B2                              */
     #if defined __IBMCPP__ || defined CMNWIN  /* @BJ                      */
              #define CSOEXPORT __cdecl/* @B6                              */
     #else                             /* @B6                              */
              #define CSOEXPORT _declspec(dllexport)   /* @B2              */
     #endif                            /* @B6                              */
     #undef FAR                        /* @B5                              */
     #define FAR                       /* @B5                              */
  #endif
 #endif                                /* @C7                              */

  #ifdef __cplusplus
    extern "C" {                           /* Assume C declarations for C++*/
  #endif                               /* __cplusplus                      */

  /* Client access initialization */
  CMCC FAR CSOEXPORT CMINIT(CMLONG *, CMCOMP *, void *, CMLONG *);   /* @B2*/
  CMCC FAR CSOEXPORT CMINITVG(CMLONG *, CMCOMP *, void *, CMLONG *); /* @FP*/

  /* Client access server call */
  CMCC FAR CSOEXPORT CMCALL(CMLONG, CMNAME *, CMLONG, CMPARM **, CMDESC **,
                         CMCOD *, CMCOMP *);                    /* @B2, @FH*/

  /* Client access close */
  CMCC FAR CSOEXPORT CMCLOSE(CMLONG, CMCOMP *);/* @B2                      */

  /* Client access commit */
  CMCC FAR CSOEXPORT CMCOMMIT(CMLONG, CMCOMP *);       /* @B2 @C4          */

  /* Internal version of CMCOMMIT, returns SQL code */
  CMCC FAR CSOEXPORT CMCOMMIT2(CMLONG, CMCOMP *, CMLONG *);

  /* Client access rollback */
  CMCC FAR CSOEXPORT CMROLLBK(CMLONG, CMCOMP *);       /* @B2 @C4          */

  /* Internal version of CMROLLBK, returns SQL code */
  CMCC FAR CSOEXPORT CMROLLBK2(CMLONG, CMCOMP *, CMLONG *);

  /* Client access convert */
  CMCC FAR CSOEXPORT CMCONV(CMLONG, CMCVOD *, CMPARM *, CMDESC *, CMCOMP *);
                                                                  /* @B2, @FH*/

  /* Client access get error */
  CMCC FAR CSOEXPORT CMGETERROR(       /* @B7                              */
             CMCOMP *Cmcomp,                   /* Completion status (input)*/
             CMLONG *errStrBufLen,      /* error string buffer length (i/o)*/
             CMMSG  *errStrBuf              /* error string buffer (output)*/
             );

  /* Client access Read From Linkage Table Into CMCOD */             /* @BF*/
  CMCC FAR CSOEXPORT CMReadFromLinkTbl(CMLONG, CMNAME *,       /* @BF      */
                                       CMCOD *, CMCOMP *);           /* @BF*/

  /* Client access Get Full Path Name For File */                    /* @BF*/
  CMCC FAR CSOEXPORT CMGetFullPathName(CMNAME *, CMNAME *);    /* @BF      */

  /* Client access Common Set Current Communication Handle */        /* @B1*/
  CMCC FAR CSOEXPORT CMSetCurrentHandle(CMLONG  *, CMCOMP *);  /* @B1      */

  /* Client access Common Get Database Version  */                   /* @B1*/
  CMCC FAR CSOEXPORT CMGetDBVersion(CMLONG, short *,  CMCOMP *);     /* @B1*/

  /* Client access Common Get Oracle Version  */                     /* @BX*/
  CMCC FAR CSOEXPORT CMGetOracleVersion(CMLONG, short *, CMCOMP *);   /*@BX*/

  /* Client access Common connect  */
  CMCC FAR CSOEXPORT CMCONCT(CMLONG, CMLONG *, CMCHAR8 *, CMCHAR8 *, CMCHAR18 *,
           CMCHAR8 *, CMCHAR8 *, CMCHAR8 *, CMSQLCA *, CMCOMP *); /* @B2, @FH*/


  /* Client access Common Converse UI Record */                      /* @C8*/
  CMCC FAR CSOEXPORT CMConverseUI(void *, short *);    /* @C8@C9           */

  /* Client access Common Get UI Record */                           /* @F1*/
  CMCC FAR CSOEXPORT CMGetUIRecord(void*, void*);      /* @F1              */


  #ifdef __cplusplus
    }                                      /* Assume C declarations for C++*/
  #endif                               /* __cplusplus                      */

#endif

/* Entry Points Structure */
                                                                    /*@F9*/
struct entryPoints
{
  /* @FA begin*/
  #ifndef CSO_MQI
  CMCC (*CMDV_INIT)(void **, CMCOMP *, void *);
  CMCC (*CMDV_CALL)(void *, CMNAME *, CMLONG, CMPARM **, CMDESC **, CMCOD *,
                    CMCOMP *, void *);                               /* @CA*/
  CMCC (*CMDV_CLOSE)(void *, CMCOMP *);
  CMCC (*CMDV_COMMIT)(void *, CMCOMP *);
  CMCC (*CMDV_ROLLBK)(void *, CMCOMP *);
  CMCC (*CMDV_CONV)();
  CMCC (*CMDV_CONCT)(void *, CMLONG, CMCHAR8 , CMCHAR8 , CMCHAR18 , CMCHAR8,
                     CMCHAR8, CMSQLCA, CMCOMP *);
  CMCC (*CMDV_MQADD)(CMLONG, void*, void*, void*, CMCOMP *);         /* @F0*/
  CMCC (*CMDV_MQSCN)(CMLONG, void*, void*, void*, CMCOMP *);         /* @F0*/
  CMCC (*CMDV_MQCLS)(CMLONG, void*, void*, CMCOMP *);                /* @F0*/
  #endif

  #ifdef CSO_MQI
     CMCC (*CMDV_INIT)(void **, CMCOMP *, void *);
     CMCC (*CMDV_CALL)(void *, CMNAME *, CMLONG, CMPARM **, CMDESC **, CMCOD *,
                    CMCOMP *, void *);                               /* @CA*/
     CMCC (*CMDV_CLOSE)(CMLONG, CMCOMP *);
     CMCC (*CMDV_COMMIT)(CMLONG, CMCOMP *);
     CMCC (*CMDV_ROLLBK)(CMLONG, CMCOMP *);
     CMCC (*CMDV_CONV)();
     CMCC (*CMDV_CONCT)(void *, CMLONG, CMCHAR8 , CMCHAR8 , CMCHAR18 , CMCHAR8,
                     CMCHAR8, CMSQLCA, CMCOMP *);
     CMCC (*CMDV_MQADD)(CMLONG, CMMSGRCD*, PMQVOID, CMPRGSTA*, CMCOMP *);
     CMCC (*CMDV_MQSCN)(CMLONG, CMMSGRCD*, PMQVOID, CMPRGSTA*, CMCOMP *);
     CMCC (*CMDV_MQCLS)(CMLONG, CMMSGRCD*, CMPRGSTA*, CMCOMP *);
  #endif
  /* @FA end */
};

/* removed conditional compile for FCW_SUN */                       /*@F9*/
                                             /*@F9*/
/* DB2 Entry Points Structure */                                     /* @B1*/
#ifdef __cplusplus                     /* @BE                              */
  extern "C" {
    struct db2entryPoints              /* @B1                              */
    {                                                                /* @B1*/
      CMCC ( SYSCALL *CMCONCT_CONNECT)(void *, CMLONG   *, CMCHAR8,  CMCHAR8,
 CMCHAR18 *, CMCHAR8 *, CMCHAR8 *, CMCHAR8 *, CMSQLCA *, CMCOMP *, int);/* @B1*/
                                                                         /*@FH*/
      CMCC ( SYSCALL *CMCONCT_COMMIT)(void *, CMCOMP *, CMLONG *);   /* @B1*/
      CMCC ( SYSCALL *CMCONCT_ROLLBACK)(void *, CMCOMP *, CMLONG *); /* @B1*/
    };                                                               /* @B1*/
  }
#else
    struct db2entryPoints              /* @B1                              */
    {                                                                /* @B1*/
      CMCC ( *CMCONCT_CONNECT)(void *, CMLONG   *, CMCHAR8,              /*@F3*/
                               CMCHAR8,  CMCHAR18 *,                /* @B1,@F3*/
                               CMCHAR8  *,  CMCHAR8  *, CMCHAR8  *, /* @B1,@F3*/
                               CMSQLCA  *, CMCOMP  *, int);         /* @B1,@F3*/
      CMCC ( *CMCONCT_COMMIT)(void *, CMCOMP *, CMLONG *);           /* @B1*/
      CMCC ( *CMCONCT_ROLLBACK)(void *, CMCOMP *, CMLONG *);         /* @B1*/
    };                                                               /* @B1*/
#endif

/* VG data format description headers */
#define SKIP_BIDI_ATTRIB_CONV  0xF2    /* flag for skipping BIDI @A1       */
                                                /*  attribute conversion  @A1 */
#define CONV_MAX_LENGTH  0xF3
#define RET_LEN_DATA     0xF4
#define DLI_SEH_DATA_LEN 0xF5
#define MAP_REC_IND      0xF6
#define SQL_REC_IND      0xF7
#define WORK_AREA        0xF8
#define INT_DATA_LEN     0xF9
#define EXT_DATA_LEN     0xFA
#define NUM_OCC_FLD_IND  0xFB
#define VAR_OCC_STR      0xFC
#define OCC_STR          0xFD
#define REC_NAME         0xFE
#define END_DESC         0xFF
#define DATA_NO_CONV     0x00
#define DATA_BIN         0x01
#define DATA_CHA         0x02
#define DATA_DBCS        0x03
#define DATA_HEX         0x04
#define DATA_MIX         0x05
#define DATA_NUM         0x06
#define DATA_NUMC        0x07
#define DATA_PACK        0x08
#define DATA_PACKF       0x09
#define DATA_PSB         0x0A          /* @BA                              */
#define DATA_BIN_AS_PICTURE   0x11     /* @BU                              */
#define DATA_NUM_AS_PICTURE   0x16     /* @BU                              */
#define DATA_NUMC_AS_PICTURE  0x17     /* @BU                              */
#define DATA_PACK_AS_PICTURE  0x18     /* @BU                              */
#define DATA_PACKF_AS_PICTURE 0x19     /* @BU                              */
#define DATA_BIN_AS_FLOAT     0x21     /* @C2                              */
#define DATA_NUM_AS_FLOAT     0x26     /* @C2                              */
#define DATA_NUMC_AS_FLOAT    0x27     /* @C2                              */
#define DATA_PACK_AS_FLOAT    0x28     /* @C2                              */
#define DATA_PACKF_AS_FLOAT   0x29     /* @C2                              */
#define DATA_BIN_AS_DOUBLE    0x31     /* @C2                              */
#define DATA_NUM_AS_DOUBLE    0x36     /* @C2                              */
#define DATA_NUMC_AS_DOUBLE   0x37     /* @C2                              */
#define DATA_PACK_AS_DOUBLE   0x38     /* @C2                              */
#define DATA_PACKF_AS_DOUBLE  0x39     /* @C2                              */

#define MAX_VALUE_1_BYTE 0xFF

/* Item description */                                               /* @C2*/
typedef struct                         /* @C2                              */
 {                                                                   /* @C2*/
 char  itemType ;                      /* @C2                              */
 short itemBytes ;                     /* @C2                              */
 } ITEMDESC ;                                                        /* @C2*/
                                                                /*@C2*/
/* Item as Signed Picture or Float Description */                    /* @C2*/
typedef struct                         /* @C2                              */
 {                                                                   /* @C2*/
 char  itemType ;                      /* @C2                              */
 short itemBytes ;                     /* @C2                              */
 short itemDecimals ;                  /* @C2                              */
 short itemClientBytes ;               /* @C2                              */
 } CLIENTITEMDESC ;                                                  /* @C2*/
                                                                /*@C2*/
/* Occurs description */                                             /* @C2*/
typedef struct                         /* @C2                              */
 {                                                                   /* @C2*/
 char  indType ;         /* OCC_STR or VAR_OCC_STR */  /* @C2              */
 short itemCount ;                     /* @C2                              */
 short itemOccurs ;                    /* @C2                              */
 } OCCURSDESC ;                                                      /* @C2*/

/*@F6 Added AIX */
#if defined FCW_HP                     /* @FI */
 #pragma pack                          /* @FI */
#elif !defined CSO400 || !defined FCW_AIX ||defined CSOWIN32             /*@F3*/
 #pragma pack()                        /* @BI                              */
#endif                                                                /*@F3*/
#endif

