#*****************************************************************************/
#*	 *************************************************************	     */
#*	 *							     *	     */
#*	 *		     OCO SOURCE	MATERIALS		     *	     */
#*	 *		       IBM CONFIDENTIAL			     *	     */
#*	 *			      OR			     *	     */
#*	 *		  IBM CONFIDENTIAL RESTRICTED		     *	     */
#*	 *    WHEN COMBINED WITH THE AGGREGATED	OCO SOURCE MODULES   *	     */
#*	 *		     FOR THIS PROGRAM PRODUCT		     *	     */
#*	 *							     *	     */
#*	 *   5622-587 (C) COPYRIGHT IBM	CORP. 1994,1997	(UNPUBLISHED)*	     */
#*	 *							     *	     */
#*	 *************************************************************	     */
#*****************************************************************************/

# Use ksh to interpret commands	(necessary for the install target)

SHELL=/bin/ksh

# ODBC variables

ODBCLIBDIR=-L/opt/odbc/lib
ODBCLIBS=-lodbc

# Workgroup Services directory
# Customize for	your system

FCWLIBDIR=/opt/vgwgs40/lib

# Workgroup Services libraries

FCWTLIBS=
FCWLIBS=-lfcwtrc $(FCWTLIBS)
CSOLIBS=-lcso40api

# C++ compiler

CC=CC

# Build	flags for modules

CSORSXO_LFLAGS=-G -pic -lC -lthread -lc

# Shared library extension for this platform

EXT=so

# Names	of libraries to	build

CSORSXOLIB=csorsxo

# Name of object files to use

CSORSXOOBJ=csorsxo.o

# Owner/Group of library files

LIBOWNER=bin
LIBGROUP=bin

########################################################
# Build	& Install
########################################################

all: build install

########################################################
# Build	target
########################################################

build:
	$(CC) $(CSORSXO_LFLAGS)	-L$(FCWLIBDIR) $(CSOLIBS) $(ODBCLIBDIR)	$(ODBCLIBS) -o $(CSORSXOLIB).$(EXT) $(FCWLIBS) $(CSORSXOOBJ)

########################################################
# Install target
########################################################

install:
	@echo Installing ODBC module into $(FCWLIBDIR)...
	chown $(LIBOWNER):$(LIBGROUP) $(CSORSXOLIB).$(EXT)
	SAVENAME=$(CSORSXOLIB).$(EXT).save.0; \
	I=1; \
	while [	-f $(FCWLIBDIR)/$$SAVENAME ]; \
	do \
	   SAVENAME=$(CSORSXOLIB).$(EXT).save.$$I; \
	   I=$$(($$I+1)); \
	done; \
	mv $(FCWLIBDIR)/$(CSORSXOLIB).$(EXT) $(FCWLIBDIR)/$$SAVENAME
	mv $(CSORSXOLIB).$(EXT)	$(FCWLIBDIR)
